diff -U3 -r1.54 status.c
--- cgi/status.c	16 Nov 2006 21:39:41 -0000	1.54
+++ cgi/status.c	5 Dec 2006 00:49:40 -0000
@@ -171,6 +171,7 @@
 
 int embedded=FALSE;
 int display_header=TRUE;
+int sounds_after_filter=FALSE; /* If true, critical services number will only reflect the filter's set */
 
 
 
@@ -721,6 +722,12 @@
 		else if(!strcmp(variables[x],"noheader"))
 			display_header=FALSE;
 
+		else if (!strcmp(variables[x], "soundsafterfilter")){
+			display_header=FALSE;
+			sounds_after_filter=TRUE;
+		       }
+
+
 		/* servicefilter cgi var */
                 else if(!strcmp(variables[x],"servicefilter")){
                         x++;
@@ -742,6 +749,7 @@
 
 /* display table with service status totals... */
 void show_service_status_totals(void){
+	regex_t preg;
 	int total_ok=0;
 	int total_warning=0;
 	int total_unknown=0;
@@ -755,6 +763,9 @@
 	int count_service;
 
 
+	if(service_filter!=NULL)
+		regcomp(&preg,service_filter,0);
+
 	/* check the status of all services... */
 	for(temp_servicestatus=servicestatus_list;temp_servicestatus!=NULL;temp_servicestatus=temp_servicestatus->next){
 
@@ -779,17 +790,17 @@
 
 			if(temp_servicestatus->status==SERVICE_CRITICAL){
 				total_critical++;
-				if(temp_servicestatus->problem_has_been_acknowledged==FALSE && temp_servicestatus->checks_enabled==TRUE && temp_servicestatus->notifications_enabled==TRUE && temp_servicestatus->scheduled_downtime_depth==0)
+				if(temp_servicestatus->problem_has_been_acknowledged==FALSE && temp_servicestatus->checks_enabled==TRUE && temp_servicestatus->notifications_enabled==TRUE && temp_servicestatus->scheduled_downtime_depth==0 && !(sounds_after_filter && service_filter!=NULL && regexec(&preg, temp_servicestatus->description,0,NULL,0)))
 					problem_services_critical++;
 			        }
 			else if(temp_servicestatus->status==SERVICE_WARNING){
 				total_warning++;
-				if(temp_servicestatus->problem_has_been_acknowledged==FALSE && temp_servicestatus->checks_enabled==TRUE && temp_servicestatus->notifications_enabled==TRUE && temp_servicestatus->scheduled_downtime_depth==0)
+				if(temp_servicestatus->problem_has_been_acknowledged==FALSE && temp_servicestatus->checks_enabled==TRUE && temp_servicestatus->notifications_enabled==TRUE && temp_servicestatus->scheduled_downtime_depth==0 && !(sounds_after_filter && service_filter!=NULL && regexec(&preg, temp_servicestatus->description,0,NULL,0)))
 					problem_services_warning++;
 			        }
 			else if(temp_servicestatus->status==SERVICE_UNKNOWN){
 				total_unknown++;
-				if(temp_servicestatus->problem_has_been_acknowledged==FALSE && temp_servicestatus->checks_enabled==TRUE && temp_servicestatus->notifications_enabled==TRUE && temp_servicestatus->scheduled_downtime_depth==0)
+				if(temp_servicestatus->problem_has_been_acknowledged==FALSE && temp_servicestatus->checks_enabled==TRUE && temp_servicestatus->notifications_enabled==TRUE && temp_servicestatus->scheduled_downtime_depth==0 && !(sounds_after_filter && service_filter!=NULL && regexec(&preg, temp_servicestatus->description,0,NULL,0)))
 					problem_services_unknown++;
 			        }
 			else if(temp_servicestatus->status==SERVICE_OK)
